#include "src\\userUsbKB\\ch32v30x_usbhs_device.h"
#include "src\\userUsbKB\\usbd_composite_km.h"

uint8_t  MessageStr[8] = {0x08, 0, 0, 0, 0, 0, 0, 0};
uint8_t  MessageRelease[8] = {0, 0, 0, 0, 0, 0, 0, 0};

void setup() {
  Serial.begin(115200);
  Serial.println("Start");
  pinMode(D18, INPUT_PULLUP);
  /* Initialize system configuration */
  SystemCoreClockUpdate( );
  NVIC_PriorityGroupConfig( NVIC_PriorityGroup_2 );
  Delay_Init( );

  /* Initialize GPIO for keyboard scan */
  KB_Scan_Init( );
  KB_Sleep_Wakeup_Cfg( );

  /* Initialize GPIO for mouse scan */
  MS_Scan_Init( );
  MS_Sleep_Wakeup_Cfg( );

  /* Initialize timer for Keyboard and mouse scan timing */
  TIM3_Init( 1, SystemCoreClock / 10000 - 1 );

  /* Initialize USBHS interface to communicate with the host  */
  USBHS_RCC_Init( );
  USBHS_Device_Init( ENABLE );
  USB_Sleep_Wakeup_CFG( );
}

unsigned long int Elsp = 0;

void loop() {
  if ( USBHS_DevEnumStatus )
  {
    /* Handle keyboard scan data */
    KB_Scan_Handle(  );

    /* Handle keyboard lighting */
    KB_LED_Handle( );

    /* Handle mouse scan data */
    MS_Scan_Handle( );

    if ((digitalRead(D18) == LOW) && (Elsp == 0)) {
      USBHS_Endp_DataUp( DEF_UEP1, MessageStr, sizeof( MessageStr ), DEF_UEP_CPY_LOAD );
      Elsp = millis();
      Serial.println("a");
    } else {
        Serial.print(millis());Serial.print("  ");Serial.println(Elsp);
      }

    if ((Elsp != 0) && (millis() - Elsp > 100)) {
      USBHS_Endp_DataUp( DEF_UEP1, MessageRelease, sizeof( MessageRelease ), DEF_UEP_CPY_LOAD );
      Elsp = 0;
      Serial.println("b");
    }
  }
}
