#include "src\\userUsbKB\\ch32v30x_usbhs_device.h"
#include "src\\userUsbKB\\usbd_composite_km.h"

uint8_t  KeyPress[8] = {0x08, 0, 0, 0, 0, 0, 0, 0};
uint8_t  KeyRelease[8] = {0, 0, 0, 0, 0, 0, 0, 0};

void setup() {
  Serial.begin(115200);
  Serial.println("Start");
  pinMode(D18, INPUT_PULLUP);
  /* Initialize system configuration */
  SystemCoreClockUpdate( );
  NVIC_PriorityGroupConfig( NVIC_PriorityGroup_2 );
  //Delay_Init( );

  /* Initialize USBHS interface to communicate with the host  */
  USBHS_RCC_Init( );
  USBHS_Device_Init( ENABLE );
  USB_Sleep_Wakeup_CFG( );
}

unsigned long PressElsp = 0;
unsigned long ReleaseElsp = 0;

void loop() {
  if ( USBHS_DevEnumStatus )
  {

    /* Handle keyboard lighting */
    KB_LED_Handle( );

    if ((digitalRead(D18) == LOW) && (PressElsp == 0) &&(millis()-ReleaseElsp>100)) {
      USBHS_Endp_DataUp( DEF_UEP1, KeyPress, sizeof( KeyPress ), DEF_UEP_CPY_LOAD );
      PressElsp = millis();
      Serial.println("a");
    }

    if ((PressElsp != 0) && (millis() - PressElsp > 1000)) {
      USBHS_Endp_DataUp( DEF_UEP1, KeyRelease, sizeof( KeyRelease ), DEF_UEP_CPY_LOAD );
      PressElsp = 0;
      ReleaseElsp=millis();
      Serial.println("b");
    }
  }
}
